﻿# Test Mailbox Database Health (Exchange 2007 Mod)
# 
# This script will look at all mailbox databases (and public folder databases)
# and determine the status of each.
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# Originally created by Jeff Roberson (jeffrey.roberson@gmail.com)
# at Bethel College, North Newton, KS
#
# Revision History
# 5/10/2010	Jeff Roberson		Creation
# 8/31/2010 John Dekowski       Modified to work with Exchange 2007-Check Database Status
#
# To execute from within NSClient++
#
#[NRPE Handlers]
#check_mailbox_health=cmd /c echo C:\Scripts\Nagios\Mbhealth2007.ps1 | PowerShell.exe -Command -
#
# On the check_nrpe command include the -t 20, since it takes some time to load
# the Exchange cmdlet's.

AddAdd-PSSnapin Microsoft.Exchange.Management.PowerShell.Admin
$NagiosStatus = "0"
$NagiosDescription = ""

Get-PublicFolderDatabase -Status | ForEach-Object {
 Write-Host $_.Name " is " $_.Mounted
	if ($_.Mounted -ne "True") {
		$NagiosStatus = "2"
				if ($NagiosDescription -ne "") {
					$NagiosDescription = $NagiosDescription + ", "
					}
					$NagiosDescription = $NagiosDescription + $_.Name + ":Dismounted"
		}
    else
		{
			$I=0
		}	
}

Get-MailboxDatabase -Status | ForEach-Object {
 	if ($_.Mounted -ne "True") {
		$NagiosStatus = "2"
				if ($NagiosDescription -ne "") {
					$NagiosDescription = $NagiosDescription + ", "
					}
					$NagiosDescription = $NagiosDescription + $_.Name + ":Dismounted"
		}
    else
		{
			$I=0
		}	
}

if ($NagiosStatus -eq "2") {
	Write-Host "CRITICAL: " $NagiosDescription
} else {
	Write-Host "OK: All Mailbox Databases are mounted."
}
exit $NagiosStatus
	